diff --git a/apt-pkg/deb/debindexfile.h b/apt-pkg/deb/debindexfile.h
index 18322dc..266a1b7 100644
--- a/apt-pkg/deb/debindexfile.h
+++ b/apt-pkg/deb/debindexfile.h
@@ -51,6 +51,8 @@ class debStatusIndex : public pkgIndexFile
    bool Merge(pkgCacheGenerator &Gen,OpProgress *Prog, unsigned long const Flag) const;
    virtual pkgCache::PkgFileIterator FindInCache(pkgCache &Cache) const;
 
+   virtual std::string LocalFileName() const {return File;};
+
    debStatusIndex(std::string File);
    virtual ~debStatusIndex() {};
 };
@@ -87,6 +89,8 @@ class debPackagesIndex : public pkgIndexFile
    virtual bool Merge(pkgCacheGenerator &Gen,OpProgress *Prog) const;
    virtual pkgCache::PkgFileIterator FindInCache(pkgCache &Cache) const;
 
+   virtual std::string LocalFileName() const {return IndexFile("Packages");};
+
    debPackagesIndex(std::string const &URI, std::string const &Dist, std::string const &Section,
 			bool const &Trusted, std::string const &Arch = "native");
    virtual ~debPackagesIndex() {};
@@ -123,6 +127,8 @@ class debTranslationsIndex : public pkgIndexFile
    virtual bool Merge(pkgCacheGenerator &Gen,OpProgress *Prog) const;
    virtual pkgCache::PkgFileIterator FindInCache(pkgCache &Cache) const;
 
+   virtual std::string LocalFileName() const {return IndexFile(Language);};
+
    debTranslationsIndex(std::string URI,std::string Dist,std::string Section, char const * const Language);
    virtual ~debTranslationsIndex() {};
 };
@@ -160,6 +166,8 @@ class debSourcesIndex : public pkgIndexFile
    virtual bool HasPackages() const {return false;};
    virtual unsigned long Size() const;
    
+   virtual std::string LocalFileName() const {return IndexFile("Sources");};
+
    debSourcesIndex(std::string URI,std::string Dist,std::string Section,bool Trusted);
    virtual ~debSourcesIndex() {};
 };
@@ -190,6 +198,8 @@ class debDebPkgFileIndex : public pkgIndexFile
    // Interface for acquire
    virtual std::string ArchiveURI(std::string /*File*/) const;
 
+   virtual std::string LocalFileName() const {return DebFile;};
+
    debDebPkgFileIndex(std::string DebFile);
    virtual ~debDebPkgFileIndex() {};
 };   
@@ -207,6 +217,7 @@ class debDscFileIndex : public pkgIndexFile
    virtual std::string Describe(bool /*Short*/) const {
       return DscFile;
    };
+   virtual std::string LocalFileName() const {return DscFile;};
 
    debDscFileIndex(std::string &DscFile);
    virtual ~debDscFileIndex() {};
diff --git a/apt-pkg/indexfile.h b/apt-pkg/indexfile.h
index 817165f..9a95725 100644
--- a/apt-pkg/indexfile.h
+++ b/apt-pkg/indexfile.h
@@ -95,6 +95,9 @@ class pkgIndexFile
    static std::string LanguageCode();
 
    bool IsTrusted() const { return Trusted; };
+
+   // returns the path of the local file (or "" if its not available)
+   virtual std::string LocalFileName() const {return "";};
    
    pkgIndexFile(bool Trusted): Trusted(Trusted) {};
    virtual ~pkgIndexFile() {};
